####  Packages to use  ######################################################

use strict;
#use Statistics::Descriptive;
use File::Copy; #NEEDED?
use Bio::TreeIO;
use IO::File;
use FindBin qw($Bin);
use Getopt::Long;

use lib $Bin;
use WMC_CONSTANTS;
use WMC;

require 'dumpvar.pl'; # NEEDED?

####  Global variables  #####################################################

my $Prog = "WMC";

####  The main section  #####################################################

#
# Analyze arguments
#
my ($Blast_Against_PDB_Out,$Out,$ID_Cutoff_Flag,$E_Value_Cutoff_Flag,$Target_File,$Output_Path,$Out_File,$Target_PDB_ID,$NR_Flag,$Only_Overlap_Mode,$Release_Year_Limit,$Phylogenetic_Mode,$Templates_PDB_ID_List,$GODZIK_Mode,$Release_Date_Limit,$Entropy_Like,$Phylogenetic_Mode_Sum,$Clusters,$Best_Templates,$Power,$Include_Very_Close,$Min_AlignmentLength,$Q_LowerLimitOnAlignmentLength,$S_LowerLimitOnAlignmentLength,$minID);



#PrmArgv ("Target_Seq= %s ! The Target Seq", \$Target_File,
#	 "Out_Path= %s ! The Output Path", \$Output_Path,
#	 "Out= %s ! The Output File", \$Out_File,
#	 
##	 "Release_Year_Limit= %s ! The Year Limit For Templates structures - consider only templates releasd prior or at this Year (Optional)", \$Release_Year_Limit,
##	 "Release_Date_Limit= %s ! The Date Limit For Templates structures - consider only templates releasd prior to that date (Optional)", \$Release_Date_Limit,
#	 "Templates_List= %s ! List If Templates PDB ID to Use - Skip looking for templates (OPTIONAL)", \$Templates_PDB_ID_List,
#	 "PSI_Blast= %s ! PSI_Blast File to get (Optional)", \$Blast_Against_PDB_Out,
#	 "Target_PDB_ID= %s ! Target_PDB_ID (optional - if given prediction file with the true label will be created)", \$Target_PDB_ID,
#	 "Power=3 %s ! Power of distance", \$Power,
#	 "Q_Align=0.5 %s ! Minimal percent of alignment overlap out of the query length (deafult=0.5)", \$Q_LowerLimitOnAlignmentLength,
#	 "S_Align=0.5 %s ! Minimal percent of alignment overlap out of the subject length (deafult=0.5)", \$S_LowerLimitOnAlignmentLength,
#	 "Min_ID=0 %s ! Minimal percent of sequence identity (deafult=0)", \$minID,
#	 "Min_Length=-1 %s ! The Min Length of template to consider (deafult= 50% of Target)", \$Min_AlignmentLength,
#	 "-ID_Cutoff ~ ! Flag to Indicate whether the PDB templates determined using Identity Cutoff as sepecified on minID Var", \$ID_Cutoff_Flag,
#	 "-E_Value_Cutoff ~ ! Flag to Indicate whether the PDB templates determined using E-Value Cutoff", \$E_Value_Cutoff_Flag,
#	 "-NR_Struct ~ ! Flag to Indicate whether to take only one uniq PDB", \$NR_Flag,
#	 "-Only_Overlap ~ ! Flag For considering only the overlap pairs in the averaging not all templates", \$Only_Overlap_Mode,
#	 "-Phylo_Mode ~ ! Consider The Phylogeneteic Information and weighted vote", \$Phylogenetic_Mode,
#	 "-Phylo_Sum_Mode ~ ! Consider The Phylogeneteic Information and weighted vote (Not Average But Only Sum)", \$Phylogenetic_Mode_Sum,
#	 "-GODZIK_Mode ~ ! Find Templates according to PDB-BLAST described at Godzik and colleagues (Protein Science 2000)", \$GODZIK_Mode,
#	 "-Entropy_Like ~ ! Flag For considering the amount of information of the paired column", \$Entropy_Like,
#	 "-Clusters ~ ! Flag For Considering Tree Clusters Of Reduandant Data (Currently Not Recurssive)", \$Clusters,
#	 "-Include_Very_Close ~ ! Consider Also The Very Close homologs (including itsels if exist)", \$Include_Very_Close,
#	 
#	 "Best_Templates= %s ! Consider Only Best X Templates", \$Best_Templates,
#	);
if (defined $ARGV[0])
{
    if ($ARGV[0] =~ m/^-/) {
	# Commandline input mode
	$Output_Path=`pwd`; # TO DO CHECK THAT ENDS WITH /
	$Power=3;
	$Q_LowerLimitOnAlignmentLength=0.5;
	$S_LowerLimitOnAlignmentLength=0.5;
	$minID=0;
	$Min_AlignmentLength=-1;
	$ID_Cutoff_Flag=0;         # FALSE 
	$E_Value_Cutoff_Flag=1;    # TRUE
	$NR_Flag='';               # FALSE
	$Only_Overlap_Mode='';     # FALSE
	$Phylogenetic_Mode='';     # FALSE
	$Phylogenetic_Mode_Sum=1;  # TRUE
	$GODZIK_Mode=1;            # TRUE
	$Entropy_Like='';          # FALSE
	$Clusters=1;               # TRUE
	$Include_Very_Close='';    # FALSE
	
	
	my $getoptResult = GetOptions ("Target_Seq=s"=>\$Target_File,  # The Target Seq    (required)
				       "Out_Path=s"=>\$Output_Path,    # The Output Path   (required)
				       "Out=s"=>\$Out_File,            # The Output File   (required)
# OPTIONAL PARAM
				       "Templates_List:s"=>\$Templates_PDB_ID_List,   # List of Templates PDB ID to Use (PDB ID FORMAT: 1CLLA for 1CLL cahin A)-
				       # don't look for templates (OPTIONAL)
				       "PSI_Blast:s"=>\$Blast_Against_PDB_Out,        # Blast File vs. PDB to start from (Optional)
				       "Target_PDB_ID:s"=>\$Target_PDB_ID,            # Target PDB ID IN FORMAT 1CLL_A (optional)
				       # If given prediction file with the true label will be created)
				       "Power:i"=>\$Power,                            # Considering the 1/Distance^Power as weight (default=3)
				       "Q_Align:f"=>\$Q_LowerLimitOnAlignmentLength,  # Minimal percent of alignment overlap out of the query length (deafult=0.5)
				       "S_Align:f"=>\$S_LowerLimitOnAlignmentLength,  # Minimal percent of alignment overlap out of the subject length (deafult=0.5)
				       "Min_ID:i"=>\$minID,                           # Minimal percent of sequence identity (deafult=0)
				       "Min_Length:i"=>\$Min_AlignmentLength,         # The Min Length of template to consider in AA sence not % (deafult= 50% of Target)
				       "Best_Templates:i"=>\$Best_Templates,          # Consider Only Best X Templates
				       "ID_Cutoff"=>\$ID_Cutoff_Flag,                 # Flag to Indicate whether the PDB templates determined using 
				       # Identity Cutoff as sepecified on Min_ID arg
				       "E_Value_Cutoff!"=>\$E_Value_Cutoff_Flag,      # Flag to Indicate whether the PDB templates determined using E-Value Cutoff
				       "NR_Struct"=>\$NR_Flag,                        # Flag to Indicate whether to take only one uniq PDB
				       "Only_Overlap"=>\$Only_Overlap_Mode,           # Flag For considering only the overlap pairs for the averaging not all templates 
				       "Phylo_Mode"=>\$Phylogenetic_Mode,             # Consider The Phylogeneteic Information and weighted vote
				       "Phylo_Sum_Mode"=>\$Phylogenetic_Mode_Sum,     # Consider The Phylogeneteic Information and weighted vote (Not Average But Only Sum)
				       "GODZIK_Mode" =>\$GODZIK_Mode,                 # Find Templates according to PDB-BLAST described at Godzik and colleagues 
				       # (Protein Science 2000)
				       "Entropy_Like" =>\$Entropy_Like,               # Flag For considering the amount of information of the paired column
				       "Clusters!" => \$Clusters,                      # Flag For Considering Tree Clusters Of Reduandant Data
				       "Include_Very_Close" => \$Include_Very_Close   # Consider Also The Very Close homologs (including itsels if exist)
				       );
    }
}
else
{
    die "USAGE: perl WMC.pl --Target_Seq <seqFile> --Out_Path <outDir> --Out <OutputName>
Optional parameters:
    --Templates_List <FILE>              # List of Templates PDB ID to Use (PDB ID FORMAT: 1CLLA for 1CLL cahin A)- don't look for templates
    --PSI_Blast <Blast_Against_PDB_Out>  # Blast File vs. PDB to start from
    --Target_PDB_ID <Target_PDB_ID>      # If given prediction file with the true label will be created) should be in IN FORMAT 1CLL_A
    --Power <NUM>                        # Considering the 1/Distance^Power as (default Power=3)
    --Q_Align <PERCENT>                  # Minimal percent of alignment overlap out of the query length (default=0.5)
    --S_Align <PERCENT>                  # Minimal percent of alignment overlap out of the subject length (deafult=0.5)
    --Min_ID <NUM>                       # Minimal percent of sequence identity (deafult=0)
    --Min_Length <NUM>                   # The Min Length of template to consider in AA sence not % of Target (deafult= 50% of Target)
    --Best_Templates <NUM>               # Consider Only Best NUM of Templates
    --ID_Cutoff                          # Flag to Indicate whether the PDB templates determined using identity Cutoff as sepecified on Min_ID Var
    --E_Value_Cutoff                     # Flag to Indicate whether the PDB templates determined using E-Value Cutoff, deafult, To disable use --noE_Value_Cutoff
    --NR_Struct                          # Flag to Indicate whether to take only one uniq PDB
    --Only_Overlap                       # Flag For considering only the overlap pairs for the averaging not all templates 
    --Phylo_Mode                         # Consider The Phylogeneteic Information and weighted vote
    --Phylo_Sum_Mode                     # Consider The Phylogeneteic Information and weighted vote (Not Average But Only Sum)
    --GODZIK_Mode                        # Find Templates according to PDB-BLAST described at Godzik and colleagues (Protein Science 2000) - default
    --Entropy_Like                       # Flag For considering the amount of information of the paired column
    --Clusters                           # Flag For Considering Tree Clusters Of Reduandant Data - default, To disable use --noClusters
    --Include_Very_Close                 # Consider Also The Very Close homologs (including itsels if exist)\n\n";
}
print "NR:$NR_Flag\tCLUST:$Clusters\n";
if  ($Clusters==0){$Clusters='';}
## BASIC VALIDATIONS
if ($Phylogenetic_Mode)
{
    $Phylogenetic_Mode_Sum='';
    print "== --Phylo_Mode is in use (--Phylo_Sum_Mode (deafult mode) is disabled)\n";
}
if ($Only_Overlap_Mode)
{
    $Phylogenetic_Mode_Sum='';
     print "== --Only_Overlap is in use (--Phylo_Sum_Mode (deafult mode) is disabled)\n";
}
if (($NR_Flag) and ($Clusters))
{
    print "WARNNING: both --NR_Struct and --Clusters are activated, are you sure?\n";
}
if (($Phylogenetic_Mode) and ($Phylogenetic_Mode_Sum))
{
    die "ONLY --Phylo_Mode OR --Phylo_Sum_Mode Can be used at the same run";
}
if ((defined ($Blast_Against_PDB_Out)) and ($GODZIK_Mode))
{
    die "ONLY --GODZIK_Mode OR --PSI_Blast  Can be used at the same run";
}
if ((defined $Templates_PDB_ID_List) and ($GODZIK_Mode))
{
    print "WARNNING: Using ONLY the list of templates: '$Templates_PDB_ID_List' and not looking for any other templates\n";
}

$Output_Path=$Output_Path."/" if ($Output_Path !~/\/$/);
system ("mkdir $Output_Path") if (!-d $Output_Path);
my $Current_Year;
my $MSA_For_Tree;

# CONST PROG and DB
#############################
my $MAFFT_PROG=WMC_CONSTANTS::MAFFT." --localpair --maxiterate 1000 --quiet ";
my $PSI_BLAST=WMC_CONSTANTS::PSI_BLAST;
my $BL2SEQ=WMC_CONSTANTS::BL2SEQ;
my $SEMPHY=WMC_CONSTANTS::SEMPHY;

my $PDB_DB=WMC_CONSTANTS::PDB_SEQ_DB;
my $NR_DATABASE=WMC_CONSTANTS::NR_SEQ_DB;
##my $CSU_CONTACT_MAP="/home/haima/Scripts/CASP9/TBM/CSU_ContactMap_MMOL_Only_With_AA_Inter_Chain_Intra_Chain_Interactions1_From_PDB_ID_with_WGET.pl"; ## TO DO IN PM - DONE
##my $TEMPLATES_CONSENSUS_SCRIPT="/home/haima/Scripts/CASP9/TBM/Templates_Consensus_Contacts_Predictor.pl"; ## TO DO IN PM
##my $TEMPLATES_CONSENSUS_SCRIPT_WITH_CLUSTERS="/home/haima/Scripts/CASP9/TBM/Templates_Consensus_Contacts_Predictor_With_Tree_Topology.pl"; ## TO DO IN PM
##my $ADD_CSU_TO_PREDICTION_FILE="/home/haima/Scripts/CASP9/Add_CSU_Contact_Map_To_Prediction_File.pl"; ## TO DO IN PM

my $Tree_Distance_Matrix;
my $Reference_Seq_Name;
#PDB Location
#=============
my $WGET_PATH=WMC_CONSTANTS::PDB_WGET_PATH;
my $PDB_Path=WMC_CONSTANTS::PDB_LOCAL_PATH;

# PARAMETERS
##################
my $MINIMAL_NUM_OF_TEMPLATES=1;
my $min_E_Value=0.00001; # TO DO: MAKE REGULAR PARAM
my $ProteinPerOrg=100;
my $Q_UpperLimitOnAlignmentLength=1;
my $S_UpperLimitOnAlignmentLength=1;
my $maxID=90;   # TO DO: MAKE REGULAR PARAM
my $maxSIM=100; #TO DO: MAKE REGULAR PARAM
my $METHOD="XRAY";
my $Target_Name;
if ($Target_File=~/([^\/]+)$/)
{
    $Target_Name=$1;
    if ($Target_Name =~/(.*).fs$/)
    {
	$Target_Name=$1;
    }
}
my $PSIBlastRound;
if (!defined $Blast_Against_PDB_Out and !defined $Templates_PDB_ID_List and !$GODZIK_Mode) # Regular Blast Against PDB
{
    $Blast_Against_PDB_Out=$Output_Path.$Target_Name.".PSI_Blast_Against_PDB";
    my $PSI_Blast_Command="$PSI_BLAST -i $Target_File -j 2 -v 2000 -b 2000 -d $PDB_DB -o $Blast_Against_PDB_Out";
    system ($PSI_Blast_Command);
    $PSIBlastRound=WMC::How_Many_Psi_Rounds($Blast_Against_PDB_Out);
}

if (!defined $Blast_Against_PDB_Out and !defined $Templates_PDB_ID_List and $GODZIK_Mode) # PDB-Blast as described at L Rychlewski, L Jaroszewski, W Li and A Godzik Protein Science (2000)
{
    # A1. Blast Of the Target seq against the NR_Good_Proteins to construct a profile
    my $PSSM_Profile_File=$Output_Path.$Target_Name.".PSSM_Profile.bin";
    my $Blast_Against_NR_Out=$Output_Path.$Target_Name.".Blast_Against_NR";
    my $Blast_Against_NR_stdout=$Output_Path.$Target_Name.".Blast_Against_NR.STDOUT";
    my $Blast_Against_NR_Profile_Command="$PSI_BLAST -d $NR_DATABASE -i $Target_File -h 1e-10 -j 3 -e 1e-3 -C $PSSM_Profile_File -o $Blast_Against_NR_Out > $Blast_Against_NR_stdout";
    if (!-e $PSSM_Profile_File)
    {
	print "$Blast_Against_NR_Profile_Command\n";
	system ($Blast_Against_NR_Profile_Command);
    }
    system ("gzip -f $Blast_Against_NR_Out") if (!-e "$Blast_Against_NR_Out.gz");
    # A2. Blast Of the profile created on A1 against The PDB DB
    $Blast_Against_PDB_Out=$Output_Path.$Target_Name.".Godzik_PDB_Blast_against_PDB";
    print "Blast_Against_PDB_Out: $Blast_Against_PDB_Out\n";
    my $Blast_Against_PDB_stdout=$Output_Path.$Target_Name.".Blast_Against_PDB.STDOUT";
    my $Blast_Against_PDB_Profile_Command="$PSI_BLAST -d $PDB_DB -i $Target_File -R $PSSM_Profile_File -j 5 -o $Blast_Against_PDB_Out > $Blast_Against_PDB_stdout";
    if (!-e $Blast_Against_PDB_Out)
    {
	system ($Blast_Against_PDB_Profile_Command);
    }
    $PSIBlastRound=WMC::How_Many_Psi_Rounds($Blast_Against_PDB_Out);
}


my $PDB_IDs_Ref;
my @PDB_IDs=();
my $Taken_PDB_Ref;
my %Taken_PDB_ID=();
my %NR_PDB_Ref=();
my $Target_Seq_And_Templates_Atom_Seq_File;
my $Templates_Contact_Maps_List;
my $Templates_Report;
if (!defined $Templates_PDB_ID_List and !$GODZIK_Mode) # Regular Blast Against PDB
{
    my @Analyze_Arg=WMC::Analyze_PSI_Blast ($Blast_Against_PDB_Out,$Q_LowerLimitOnAlignmentLength,$Min_AlignmentLength,$S_LowerLimitOnAlignmentLength,$minID,$ProteinPerOrg,$Q_UpperLimitOnAlignmentLength,$S_UpperLimitOnAlignmentLength,$maxID,$PSIBlastRound,$min_E_Value,$maxSIM,$E_Value_Cutoff_Flag,$ID_Cutoff_Flag,$METHOD);
    
    print "== TEMPLATES WERE CHOOSEN BASED ON:\n";
    print "Q_LowerLimitOnAlignmentLength: $Q_LowerLimitOnAlignmentLength";
    print " OR Above $Min_AlignmentLength" if ($Min_AlignmentLength!=-1); 
    print "\nS_LowerLimitOnAlignmentLength: $S_LowerLimitOnAlignmentLength\nmaxID:$maxID\nQ_UpperLimitOnAlignmentLength:$Q_UpperLimitOnAlignmentLength\nS_UpperLimitOnAlignmentLength:$S_UpperLimitOnAlignmentLength\nProteinPerOrg:$ProteinPerOrg\nMethod:$METHOD\n";
    print "min_E_Value: $min_E_Value\n" if ($E_Value_Cutoff_Flag);
    print "minID: $minID\n" if ($ID_Cutoff_Flag);
    
    $PDB_IDs_Ref=$Analyze_Arg[0];
    @PDB_IDs=@$PDB_IDs_Ref;
    $Taken_PDB_Ref=$Analyze_Arg[1];
    %Taken_PDB_ID=%$Taken_PDB_Ref;
    $Target_Seq_And_Templates_Atom_Seq_File=$Output_Path.$Target_Name."_Reference_and_Templates_Atoms_Seq";
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File."_With_Redundant" if (!$NR_Flag);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Best_$Best_Templates"."_Templates" if (defined $Best_Templates);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    $Templates_Contact_Maps_List=$Output_Path."List_Of_ContactMaps_For_$Target_Name"."_Homologs";
    $Templates_Contact_Maps_List.$Templates_Contact_Maps_List."_With_Redundant" if (!$NR_Flag); 
    $Templates_Contact_Maps_List.$Templates_Contact_Maps_List.".Best_$Best_Templates"."_Templates" if (defined $Best_Templates);
    $Templates_Contact_Maps_List.$Templates_Contact_Maps_List.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Templates_Contact_Maps_List.$Templates_Contact_Maps_List.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    $Templates_Report=$Output_Path.$Target_Name.".Templates_Report";
    $Templates_Report=$Templates_Report.".Best_$Best_Templates"."_Templates" if ($Best_Templates);
    $Templates_Report=$Templates_Report."_With_Redundant" if (!$NR_Flag);
    $Templates_Report=$Templates_Report.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Templates_Report=$Templates_Report.".Min_Alig$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
}
      
if (!defined $Templates_PDB_ID_List and $GODZIK_Mode) # Based On GODZIK PDB-Blast
{
    print "Blast_Against_PDB_Out: $Blast_Against_PDB_Out\n";
    my @Analyze_Arg=WMC::Analyze_PSI_Blast ($Blast_Against_PDB_Out,$Q_LowerLimitOnAlignmentLength,$Min_AlignmentLength,$S_LowerLimitOnAlignmentLength,$minID,$ProteinPerOrg,$Q_UpperLimitOnAlignmentLength,$S_UpperLimitOnAlignmentLength,$maxID,$PSIBlastRound,$min_E_Value,$maxSIM,$E_Value_Cutoff_Flag,$ID_Cutoff_Flag,$METHOD);
    print "== TEMPLATES WERE CHOOSEN BASED ON:\nQ_LowerLimitOnAlignmentLength: $Q_LowerLimitOnAlignmentLength";
    print " OR Above $Min_AlignmentLength" if ($Min_AlignmentLength!=-1); 
    print "\nS_LowerLimitOnAlignmentLength: $S_LowerLimitOnAlignmentLength\nmaxID:$maxID\nQ_UpperLimitOnAlignmentLength:$Q_UpperLimitOnAlignmentLength\nS_UpperLimitOnAlignmentLength:$S_UpperLimitOnAlignmentLength\nProteinPerOrg:$ProteinPerOrg\nMethod:$METHOD\n";
    print "min_E_Value: $min_E_Value\n" if ($E_Value_Cutoff_Flag);
    print "minID: $minID\n" if ($ID_Cutoff_Flag);
    print "According to PDB-Blast protocol suggested by: L Rychlewski, L Jaroszewski, W Li and A Godzik Protein Science (2000)\n";
    
    $PDB_IDs_Ref=$Analyze_Arg[0];
    @PDB_IDs=@$PDB_IDs_Ref;
    $Taken_PDB_Ref=$Analyze_Arg[1];
    %Taken_PDB_ID=%$Taken_PDB_Ref;
    $Target_Seq_And_Templates_Atom_Seq_File=$Output_Path.$Target_Name."_Reference_and_GODZIK_PDB_Blast_Templates_Atoms_Seq";
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File."_With_Redundancy" if (!$NR_Flag);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Best_$Best_Templates"."_Templates" if (defined $Best_Templates);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    
    $Templates_Contact_Maps_List=$Output_Path."List_Of_ContactMaps_For_$Target_Name"."_GODZIK_PDB_Blast_Homologs";
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List."_With_Redundant" if (!$NR_Flag);
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List.".Best_$Best_Templates"."_Templates" if (defined $Best_Templates);
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    
    $Templates_Report=$Output_Path.$Target_Name.".GODZIK_PDB_Blast_Templates_Report";
    $Templates_Report=$Templates_Report.".Best_$Best_Templates"."_Templates" if ($Best_Templates);
    $Templates_Report=$Templates_Report."_With_Redundancy" if (!$NR_Flag);
    $Templates_Report=$Templates_Report.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Templates_Report=$Templates_Report.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
}

if (defined $Templates_PDB_ID_List) # BASED On Given Templates PDB ID
{
    my $Analyze_Report_File="$Templates_PDB_ID_List".".Anlyze_Report";
    $Analyze_Report_File=$Analyze_Report_File."_With_Redundant" if (!$NR_Flag);
    $Analyze_Report_File=$Analyze_Report_File.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Analyze_Report_File=$Analyze_Report_File.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    open (ERROR,">$Analyze_Report_File") || die "Can't open Analyze Report File: '$Analyze_Report_File' $!";
    open (TEMPLATES_PDB_LIST,$Templates_PDB_ID_List) || die "Can't Open The List With Templates PDBs '$Templates_PDB_ID_List' $!";
    while (my $PDB_ID=<TEMPLATES_PDB_LIST>)
    {
	chomp ($PDB_ID);
	print "PDB:$PDB_ID\n";#<STDIN>;
	open (PDB_DETAILS,"grep \"\\b$PDB_ID\\b\" $PDB_DB |") || die "Can't grep \\b$PDB_ID\\b $PDB_DB | $!";
	my $PDB_Details=<PDB_DETAILS>;
	close (PDB_DETAILS);
	if ($PDB_Details =~ /^\>([A-Za-z0-9_]+)\s+(.*)\<(.+)\>\s+\[(.+)\].*/)
	{
	    # Extract the organism from [] put 1 in $Organisms{$3} and consider only the first hit of every organism. Some SP do not have [], but only _organism, so at the second stage make sure _HUMAN=[Homo Sapiens].
	    my $PDB_Details_ID=$1;
	    my @Annotation=split (/\s+/,$2);
	    my $PDB_Reference_Seq_Name=$3;
	    my $orgn=$4; 
	    if ($PDB_ID eq $PDB_Details_ID)
	    {		    
		$Taken_PDB_ID{$PDB_ID}{'ID'}="NA";
		$Taken_PDB_ID{$PDB_ID}{'Q_AlignmentLength'}="NA";
		$Taken_PDB_ID{$PDB_ID}{'S_AlignmentLength'}="NA";
		$Taken_PDB_ID{$PDB_ID}{'Organism'}=$orgn;
		$Taken_PDB_ID{$PDB_ID}{'Length'}=$Annotation[0];
		$Taken_PDB_ID{$PDB_ID}{'Method'}=$Annotation[1];
		$Taken_PDB_ID{$PDB_ID}{'Resolution'}=$Annotation[2];
		$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}=$PDB_Reference_Seq_Name;
		$Taken_PDB_ID{$PDB_ID}{'E_Value'}="NA";
		$Taken_PDB_ID{$PDB_ID}{'SIM'}="NA";
		push (@PDB_IDs,$PDB_ID);
	    }
	}
	if (!$ID_Cutoff_Flag) # NO FILTER ON PDB LIST
	{
	    push (@PDB_IDs,$PDB_ID);
	}
	elsif ($ID_Cutoff_Flag) #Filter Templates Lower Than ID_Cutoff or released After CASP Target
	{
	    my $QueryGI;
	    my $QueryLength;
	    
	    my $Tmp_PDB_Seq_File=$Output_Path.$PDB_ID.".fs";
	    system ("grep -A1 \"\\b$PDB_ID\\b\" $PDB_DB > $Tmp_PDB_Seq_File");
	    open (BL2SEQ,"$BL2SEQ -i $Target_File -j $Tmp_PDB_Seq_File -p blastp -F f |") || die "Can't Blast 2 Seq: '$BL2SEQ -i $Target_File -j $Tmp_PDB_Seq_File -p blastp -F f' $!";
	    my $line=<BL2SEQ>;
	    while ($line and ($line!~/^Query\= (T[0-9]+)/) and ($line!~/^Query\= gi\|(\d+_*\d*)\|/) and ($line!~/^Query\= ([A-Za-z0-9_]+).*/)) {$line=<BL2SEQ>;}
	    if ($line and (($line=~/^Query\= gi\|(\d+_*\d*)\|/) or ($line=~/^Query\= (T[0-9]+)/)) or ($line=~/^Query\= ([a-zA-Z0-9_]+)/))
	    {
		chomp($line);
		my $Annotation=$line;
		#	print "ANNOTATION:$Annotation\n";<STDIN>; 
		while ($line and ($line!~/\((\d+)\s+letters/)) {$line=<BL2SEQ>; chomp($line); $Annotation.=" $line";}
		
		$Annotation=~s/\s+/ /g;
		if( ($Annotation =~ /^Query\= gi\|(\d+_*\d*)\|\[(.+)\]\|.*\((\d+) letters\)/) or 
		    ($Annotation =~ /^Query\= gi\|(\d+_*\d*)\|\s*(\S*)\s*\|.*\((\d+) letters\)/))
		{
		    $QueryGI=$1;
		    #print "$QueryGI\n";
		    $QueryLength=$3;
		}
		elsif (($Annotation =~ /^Query\= (T[0-9]+).*\((\d+) letters\)/))
		{
		    $QueryGI=$1;
		    $QueryLength=$2;
		}
		elsif (($Annotation =~ /^Query\= ([A-Za-z0-9_]+).*\((\d+) letters\)/)) # FOR CASP TARGETS FORMAT
		{
		    $QueryGI=$1;
		    $QueryLength=$2;
		}
		else 
		{
		    print ERROR "Query Expected in Annotation=$Annotation\n"; 
		    return 0;
		}
	    }
	    else 
	    {
		print ERROR "Query Expected in $line\n";
	    }
	    while (my $line=<BL2SEQ>)
	    {
		last if ($line =~ /Number of sequences/);
		while ($line and ($line!~/^\>/)&&($line !~ /Number of sequences/)) {$line=<BL2SEQ>;}
		last if ($line =~ /Number of sequences/);
		
		chomp($line);
		my $Annotation=$line;
		while ($line and ($line!~/Length \= /)) {$line=<BL2SEQ>; chomp($line); $Annotation.=$line;}
		$Annotation=~s/\s+/ /g;
		if ($Annotation =~ /^\>([A-Za-z0-9_]+)\s+(.*)\<(.+)\>\s+\[(.+)\].*Length\s+=\s+(\d+)/)
		{
		    my $PDB_ID=$1;
		    my @Annotation=split (/\s+/,$2);
		    my $PDB_Reference_Seq_Name=$3;
		    my $SubjectLength=$5;
		    while ($line and $line!~/Score \=/) {$line=<BL2SEQ>;}
		    chomp ($line);
		    my $line1=<BL2SEQ>;
		    $line=$line.$line1;
		    if ($line =~ /Identities \= \d+\/\d+ \((\d+)\%\)\, Positives \= \d+\/\d+ \((\d+)\%\)/) 
		    {
			my $ID=$1;
			my $Sim=$2;
			my $E_Value=$1 if ($line =~/Expect\s+=\s+([e0-9.\-]+)/);
			$E_Value="1".$E_Value if ($E_Value=~/^e-/);
			my ($Q_AlignmentLength,$S_AlignmentLength); 
			my ($Query,$Sbjct);
			while ($line and ($line!~/^Query/)) {$line=<BL2SEQ>;}
			while ($line =~ /^Query/)
			{
			    chomp($line);
			    $Query.=$line;
			    $line=<BL2SEQ>;
			    $line=<BL2SEQ>;
			    chomp($line);
			    $Sbjct.=$line;
			    $line=<BL2SEQ>; 
			    $line=<BL2SEQ>;
			}
			
			if ($Query=~/^Query: (\d+)\s+.+\s+(\d+)$/)
			{
			    my $Start=$1; my $End=$2;
			    $Q_AlignmentLength=$End-$Start+1;
			}
			else {print ERROR "Problem in Query Format of $PDB_ID: $Query";}
			
			if ($Sbjct=~/^Sbjct: (\d+)\s+.+\s+(\d+)$/)
			{
			    my $Start=$1; my $End=$2;
			    $S_AlignmentLength=$End-$Start+1;
			}
			else {print ERROR "Problem in Sbjct Format of $PDB_ID: $Sbjct";}
			## START FILTERS
			if ($ID<$minID and $ID_Cutoff_Flag)
			{print ERROR "PDB_ID=$PDB_ID has only $ID percent identity\n";}
			elsif ($ID>$maxID and !$Include_Very_Close)
			{
			    print ERROR "PDB_ID=$PDB_ID has $ID percent identity while Proteins With more Than $maxID Mot Considered\n";}
			else # TAKE THE AS TEMPLATE
			{
			    $Taken_PDB_ID{$PDB_ID}{'ID'}=$ID if (defined $ID);
			    $Taken_PDB_ID{$PDB_ID}{'Q_AlignmentLength'}=$Q_AlignmentLength if (defined $Q_AlignmentLength);
			    $Taken_PDB_ID{$PDB_ID}{'S_AlignmentLength'}=$S_AlignmentLength if (defined $S_AlignmentLength);
			    $Taken_PDB_ID{$PDB_ID}{'E_Value'}=$E_Value if (defined $E_Value);
			    $Taken_PDB_ID{$PDB_ID}{'SIM'}=$Sim if (defined $Sim);
			    push (@PDB_IDs,$PDB_ID);
			}
		    }
		}
	    }
#	    unlink $Tmp_PDB_Seq_File;
	}
	
    }
    close (ERROR);
    close (BL2SEQ);
    
    $Target_Seq_And_Templates_Atom_Seq_File=$Output_Path.$Target_Name."_Reference_and_Templates_Atoms_Seq.Based_On_Predefined_Templates_List";
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File."_With_Redundant" if (!$NR_Flag);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Best_$Best_Templates"."_Templates" if (defined $Best_Templates);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Target_Seq_And_Templates_Atom_Seq_File=$Target_Seq_And_Templates_Atom_Seq_File.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    
    $Templates_Contact_Maps_List=$Output_Path."List_Of_ContactMaps_For_$Target_Name"."_Homologs.Based_On_Predefined_Templates_List";
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List."_With_Redundant" if (!$NR_Flag);
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List.".Best_$Best_Templates"."_Templates" if (defined $Best_Templates);
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Templates_Contact_Maps_List=$Templates_Contact_Maps_List.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    
    $Templates_Report=$Output_Path.$Target_Name."_Based_On_Predefined_Templates_List.Templates_Report";
    $Templates_Report=$Templates_Report.".Best_$Best_Templates"."_Templates" if ($Best_Templates);
    $Templates_Report=$Templates_Report."_With_Redundant" if (!$NR_Flag);
    $Templates_Report=$Templates_Report.".Including_Very_Close_Homologs" if ($Include_Very_Close);
    $Templates_Report=$Templates_Report.".Min_Align$Min_AlignmentLength" if ($Min_AlignmentLength>-1);
}
print "cat $Target_File > $Target_Seq_And_Templates_Atom_Seq_File\n";
system ("cat $Target_File > $Target_Seq_And_Templates_Atom_Seq_File");
open (TARGET_AND_TEMPLATES_SEQ,">>$Target_Seq_And_Templates_Atom_Seq_File") || die "Can't Open Target and Templates seq File for writing '$Target_Seq_And_Templates_Atom_Seq_File' $!";
open (CONTACT_MAP_LIST,">$Templates_Contact_Maps_List") || die "Cna't Open The List For Homologs Contacts Map: $Templates_Contact_Maps_List' $!";
open (TEMPLATES_REPORT,">$Templates_Report") || die "Can't Open Templates Report File '$Templates_Report' $!";
if (!defined $Templates_PDB_ID_List and !$GODZIK_Mode) # Regular Blast
{
    print TEMPLATES_REPORT "== TEMPLATES WERE CHOOSEN BASED ON:\nQ_LowerLimitOnAlignmentLength: $Q_LowerLimitOnAlignmentLength";
    print TEMPLATES_REPORT " OR Above $Min_AlignmentLength" if ($Min_AlignmentLength!=-1);
    print TEMPLATES_REPORT "\nS_LowerLimitOnAlignmentLength: $S_LowerLimitOnAlignmentLength\nQ_UpperLimitOnAlignmentLength:$Q_UpperLimitOnAlignmentLength\nS_UpperLimitOnAlignmentLength:$S_UpperLimitOnAlignmentLength\nProteinPerOrg:$ProteinPerOrg\nMethod:$METHOD\n";
    print TEMPLATES_REPORT "maxID:$maxID\n" if (!$Include_Very_Close);
    if (!$Include_Very_Close)
    {
	print TEMPLATES_REPORT "Max_ID=$maxID\n";
	print TEMPLATES_REPORT "Max_Sim=$maxSIM\n";
    }
    print TEMPLATES_REPORT "min_E_Value: $min_E_Value\n" if ($E_Value_Cutoff_Flag);
    print TEMPLATES_REPORT "minID: $minID\n" if ($ID_Cutoff_Flag);
    print TEMPLATES_REPORT "All Structures Were Resulted from $PSIBlastRound PSI-Blast Iterations\n";
}
elsif (!defined $Templates_PDB_ID_List and $GODZIK_Mode) # Based On GODZIK PDB-Blast
{
    print TEMPLATES_REPORT "== TEMPLATES WERE CHOOSEN BASED ON:\nQ_LowerLimitOnAlignmentLength: $Q_LowerLimitOnAlignmentLength";
    print TEMPLATES_REPORT " OR Above $Min_AlignmentLength" if ($Min_AlignmentLength>-1);
    print TEMPLATES_REPORT "\nS_LowerLimitOnAlignmentLength: $S_LowerLimitOnAlignmentLength\nQ_UpperLimitOnAlignmentLength:$Q_UpperLimitOnAlignmentLength\nS_UpperLimitOnAlignmentLength:$S_UpperLimitOnAlignmentLength\nProteinPerOrg:$ProteinPerOrg\nMethod:$METHOD\n";
    print TEMPLATES_REPORT "maxID:$maxID\n" if (!$Include_Very_Close);
    if (!$Include_Very_Close)
    {
	print TEMPLATES_REPORT "Max_ID=$maxID\n";
	print TEMPLATES_REPORT "Max_Sim=$maxSIM\n";
    }
    print TEMPLATES_REPORT "min_E_Value: $min_E_Value\n" if ($E_Value_Cutoff_Flag);
    print TEMPLATES_REPORT "minID: $minID\n" if ($ID_Cutoff_Flag);
    print TEMPLATES_REPORT "All Structures Were Resulted from $PSIBlastRound PSI-Blast Iterations and with profile as was described at PDB-Blast Method suggested by: L Rychlewski, L Jaroszewski, W Li and A Godzik Protein Science (2000)\n";
}
elsif (defined $Templates_PDB_ID_List) # Base On Templates List
{
    print TEMPLATES_REPORT "== TEMPLATES WERE CHOOSEN BASED ON PDBs Templates Specified at: $Templates_PDB_ID_List\n";
}

### START PROCESSING ###
my @Taken_Best_Templates;


if (defined $Best_Templates) # Work Only With Best X Templates
{
    # Print The Templates Report
    print TEMPLATES_REPORT "All Templates (including Redundant Data) Founds\n###############################################\n";
    foreach my $PDB_ID (@PDB_IDs)
    { 
	if ($Taken_PDB_ID{$PDB_ID}{'Method'} eq $METHOD and $METHOD ne "ALL")
	{
	    my $PDB_ID_With_Chain=substr($PDB_ID,0,4)."_".substr($PDB_ID,-1);
	    print TEMPLATES_REPORT "$PDB_ID_With_Chain\t$Taken_PDB_ID{$PDB_ID}{'ID'}\t$Taken_PDB_ID{$PDB_ID}{'SIM'}\t$Taken_PDB_ID{$PDB_ID}{'Q_AlignmentLength'}\t$Taken_PDB_ID{$PDB_ID}{'S_AlignmentLength'}\t$Taken_PDB_ID{$PDB_ID}{'Organism'}\t$Taken_PDB_ID{$PDB_ID}{'Length'}\t$Taken_PDB_ID{$PDB_ID}{'Method'}\t$Taken_PDB_ID{$PDB_ID}{'Resolution'}\t$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}\t$Taken_PDB_ID{$PDB_ID}{'E_Value'}\n"#\t$Taken_PDB_ID{$PDB_ID}{'Release_Date'}\n";
	}
    }
    #SORTING TEMPLATES ACCORDING TO %ID and Resolution
    #####################################################
    my @Sorted;
    foreach my $PDB (sort { $Taken_PDB_ID {$b}{'ID'} <=> $Taken_PDB_ID {$a}{'ID'}} keys %Taken_PDB_ID )
    {
	if ($Taken_PDB_ID{$PDB}{'Method'} eq $METHOD and $METHOD ne "ALL") # ONLY X RAY STRUCTURES
	{
	    push (@Sorted,$PDB);
	    print "$PDB\t$Taken_PDB_ID{$PDB}{'ID'}\t$Taken_PDB_ID{$PDB}{'Resolution'}\n";
	}
    }
    for (my $i=0;$i<scalar @Sorted;$i++)
    {
	if ($Taken_PDB_ID{$Sorted[$i]}{'ID'} eq $Taken_PDB_ID{$Sorted[$i+1]}{'ID'})
	{
	    if ($Taken_PDB_ID{$Sorted[$i]}{'Resolution'} > $Taken_PDB_ID{$Sorted[$i+1]}{'Resolution'})
	    {
		my $tmp=$Sorted[$i];
		$Sorted[$i]=$Sorted[$i+1];
		$Sorted[$i+1]=$tmp;
		$i=0;
	    }
	}
    }
    # CHOOSE THE BEST TEMPLATES
    #############################
    my $Taken_Templates=0;
    my %tmp_NR_PDB_Ref=();
    for (my $i=0;$Taken_Templates<$Best_Templates;$i++)
    {
	my $PDB_ID=$Sorted[$i];
	if (!defined $PDB_ID) # END OF ARRAY
	{
	    $Taken_Templates=$Best_Templates; 
	}
	if (!defined ($tmp_NR_PDB_Ref{$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}}) and $NR_Flag) # NR IMPOSED
	{
	    if (WMC::PDB_Exist($PDB_ID))
	    {
		$tmp_NR_PDB_Ref{$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}}=$PDB_ID;
		push (@Taken_Best_Templates,$PDB_ID);
		$Taken_Templates++;
	    }
	    else #PDB DOES NOT EXIST ## TO DO: CHECK THAT
	    {
#		print "$PDB_ID Does Not Exist\n";#QA
#		$i--;
	    }
	}
	elsif (defined ($tmp_NR_PDB_Ref{$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}}) and $NR_Flag) # NR IMPOSED
	{
	    $Taken_Templates=$Taken_Templates;
#	    $i--; #IGNORE THE TEMPLATE
	}
	
	elsif (defined ($tmp_NR_PDB_Ref{$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}}) and !$NR_Flag) # NR NOT IMPOSED
	{
	    push (@Taken_Best_Templates,$PDB_ID); # TAKE THE REDUNDANT TEMPLATE
#	    print "TAKE: $PDB_ID\n";#QA
#	    $i--;  # DONT COUNT THE TEMPLATE WHERAS IT REDUNDANT
	}
	elsif (!defined ($tmp_NR_PDB_Ref{$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}}) and !$NR_Flag) # NR NOT IMPOSED
	{
	    push (@Taken_Best_Templates,$PDB_ID); # TAKE THE REDUNDANT TEMPLATE
#	    print "TAKE: $PDB_ID\n";#QA
	    $Taken_Templates++;
	}
    }
    print "### THE CHOOSEN TEMPLATES ARE ###\n"; # QA
# QA
	foreach my $PDB (@Taken_Best_Templates)
    {
	print "$PDB\t$Taken_PDB_ID{$PDB}{'ID'}\t$Taken_PDB_ID{$PDB}{'Resolution'}\t$Taken_PDB_ID{$PDB}{'Ref_Seq_Name'}\n";
    }
}
@PDB_IDs=@Taken_Best_Templates if ($Best_Templates);
my $Num_Of_Templates=@PDB_IDs;
print "FOUND $Num_Of_Templates TEMPLATES\n#######################################\n";
my @Chosen_Templates;
foreach my $PDB_ID (@PDB_IDs)
{ 
    if ($Taken_PDB_ID{$PDB_ID}{'Method'} eq $METHOD)
    {
	my $Take_The_PDB_Flag=0; # DONT TAKE THE PDB
	if (!defined ($NR_PDB_Ref{$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}}) and $NR_Flag) # NR imposed
	{
	    $Take_The_PDB_Flag=1;
	}
	if (!$NR_Flag) # Take All 
	{
	    $Take_The_PDB_Flag=1;
	}
	if ($Take_The_PDB_Flag==1)
	{
	    my $PDB_ID_With_Chain=substr($PDB_ID,0,4)."_".substr($PDB_ID,-1);
	    my $Chain_ID;
	    my $PDB_Name;
	    if ($PDB_ID_With_Chain=~/([0-9a-zA-Z]{4})_([0-9a-zA-Z])/)
	    {
		$Chain_ID=$2;
		$PDB_Name=$1;
	    }
	    #Chek For PDB ID
	    #=====================
	    my $PDB_ID_Flag=0;
	    my $PDB_Exist=0;
	    my $Tmp_PDB_File;
	    my $PDB_Not_Found=0;
	    if (defined $PDB_ID)
	    {
		my $PDB_ID_Name=lc($PDB_ID);
		my $PDB_File=$PDB_Path.substr($PDB_ID_Name, 1,2)."/pdb".substr($PDB_ID_Name, 0,4).".ent.gz";
		$Tmp_PDB_File=$Output_Path.substr($PDB_ID_Name, 0,4).".ent";
		if (-e  $PDB_File)
		{
		    system ("zcat $PDB_File | grep -v \"ANISOU\" > $Tmp_PDB_File");
		    $PDB_Exist=1;
		}
		else
		{
		    my $cmd="wget ".$WGET_PATH.substr($PDB_ID_Name, 1,2)."/pdb".substr($PDB_ID_Name, 0,4).".ent.gz -O $Tmp_PDB_File".".gz";
		    print "=== DOWNLOADING PDB $PDB_ID from RCSB to $Tmp_PDB_File\n";
		    system ($cmd);
		    system ("zcat $Tmp_PDB_File.gz | grep -v \"ANISOU\" > $Tmp_PDB_File");
		    system ("rm -f $Tmp_PDB_File.gz");
		    $PDB_Exist=1;
		    if (!-e $Tmp_PDB_File)
		    {
			print "=== PDB WAS NOT FOUND: $PDB_File\n";
			$PDB_Not_Found=1;
			# exit (0);
		    }
		}
	    }
	    my $Seq=WMC::From_PDB_ATOMS_To_Seq($Tmp_PDB_File,$Chain_ID) if ($PDB_Exist);
	    unlink $Tmp_PDB_File if ($PDB_Exist);
	    push (@Chosen_Templates,$PDB_ID) if ($PDB_Exist);
	    print TARGET_AND_TEMPLATES_SEQ $Seq if ($PDB_Exist and defined $Seq);
	    ## CREATE TEMPLATES CONTACTS MAP
	    #################################
	    my $CSU_MAP="$Output_Path"."$PDB_ID_With_Chain".".CSU";
	    WMC::CSU_CONTACT_MAP($PDB_ID_With_Chain,$Output_Path,$Output_Path) if (!-e $CSU_MAP and $PDB_Exist);
	    print CONTACT_MAP_LIST "$CSU_MAP\n" if ($PDB_Exist);
	    print "$PDB_ID_With_Chain\t$Taken_PDB_ID{$PDB_ID}{'ID'}\t$Taken_PDB_ID{$PDB_ID}{'SIM'}\t$Taken_PDB_ID{$PDB_ID}{'Q_AlignmentLength'}\t$Taken_PDB_ID{$PDB_ID}{'S_AlignmentLength'}\t$Taken_PDB_ID{$PDB_ID}{'Organism'}\t$Taken_PDB_ID{$PDB_ID}{'Length'}\t$Taken_PDB_ID{$PDB_ID}{'Method'}\t$Taken_PDB_ID{$PDB_ID}{'Resolution'}\t$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}\t$Taken_PDB_ID{$PDB_ID}{'E_Value'}\n" if ($PDB_Exist);
	    $NR_PDB_Ref{$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}}=$PDB_ID;
	}
	else
	{
	    my $PDB_ID_With_Chain=substr($PDB_ID,0,4)."_".substr($PDB_ID,-1);
	    print TEMPLATES_REPORT "### $PDB_ID_With_Chain belonging to $Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'} NOT USED AGAIN: \%ID:$Taken_PDB_ID{$PDB_ID}{'ID'} Q_Align_Length:$Taken_PDB_ID{$PDB_ID}{'Q_AlignmentLength'} S_AlignmentLength: $Taken_PDB_ID{$PDB_ID}{'S_AlignmentLength'} Resulution: $Taken_PDB_ID{$PDB_ID}{'Resolution'}\n";# Released: $Taken_PDB_ID{$PDB_ID}{'Release_Date'}\n";
	}
    }
}
close (TARGET_AND_TEMPLATES_SEQ);
print TEMPLATES_REPORT "\n\nCHOSEN TEMPLATES:\n" if (!defined $Best_Templates);
print TEMPLATES_REPORT "\n\nTHE BEST $Best_Templates CHOSEN TEMPLATES:\n" if (defined $Best_Templates);

print TEMPLATES_REPORT "PDB_ID\t%ID\t%SIM\tQ_AlignmentLength\tS_AlignmentLength\tOrganism\tPDB_Length\tPDB_Method\tResolution\tRef_Seq_Name\tE_Value\n";
#QA REPORT
#foreach my $PDB_ID (@PDB_IDs)

#my $All_Templates_ID_Statistics=Statistics::Descriptive::Full->new();
#my $All_Templates_SIM_Statistics=Statistics::Descriptive::Full->new();

foreach my $PDB_ID (@Chosen_Templates)
{ 
    if ($Taken_PDB_ID{$PDB_ID}{'Method'} eq $METHOD and $METHOD ne "ALL")
    {
	my $PDB_ID_With_Chain=substr($PDB_ID,0,4)."_".substr($PDB_ID,-1);
	print TEMPLATES_REPORT "$PDB_ID_With_Chain\t$Taken_PDB_ID{$PDB_ID}{'ID'}\t$Taken_PDB_ID{$PDB_ID}{'SIM'}\t$Taken_PDB_ID{$PDB_ID}{'Q_AlignmentLength'}\t$Taken_PDB_ID{$PDB_ID}{'S_AlignmentLength'}\t$Taken_PDB_ID{$PDB_ID}{'Organism'}\t$Taken_PDB_ID{$PDB_ID}{'Length'}\t$Taken_PDB_ID{$PDB_ID}{'Method'}\t$Taken_PDB_ID{$PDB_ID}{'Resolution'}\t$Taken_PDB_ID{$PDB_ID}{'Ref_Seq_Name'}\t$Taken_PDB_ID{$PDB_ID}{'E_Value'}\n";#\t$Taken_PDB_ID{$PDB_ID}{'Release_Date'}\n";
#	$All_Templates_ID_Statistics->add_data($Taken_PDB_ID{$PDB_ID}{'ID'}) if ($Taken_PDB_ID{$PDB_ID}{'ID'} ne "NA");
#	$All_Templates_SIM_Statistics->add_data($Taken_PDB_ID{$PDB_ID}{'SIM'}) if ($Taken_PDB_ID{$PDB_ID}{'SIM'} ne "NA");
    }
}
print TEMPLATES_REPORT "\n\n #### TOTAL ####\n";
    print TEMPLATES_REPORT $#Chosen_Templates+1," Templates Were Used\n";
#print TEMPLATES_REPORT "Average ",$All_Templates_ID_Statistics->mean()," \%ID STD ",$All_Templates_ID_Statistics->standard_deviation(),"\n";
#print TEMPLATES_REPORT "Average ",$All_Templates_SIM_Statistics->mean()," \%Sim STD ",$All_Templates_SIM_Statistics->standard_deviation(),"\n";

if ($Num_Of_Templates>=$MINIMAL_NUM_OF_TEMPLATES)
{
    ## CREATE THE MSA
    ####################
    print "$MAFFT_PROG $Target_Seq_And_Templates_Atom_Seq_File > $Target_Seq_And_Templates_Atom_Seq_File.mfa\n";
    system ("$MAFFT_PROG $Target_Seq_And_Templates_Atom_Seq_File > $Target_Seq_And_Templates_Atom_Seq_File.mfa");# if (!-e "$Target_Seq_And_Templates_Atom_Seq_File.mfa");
    my $Tree_File;
    ## Calculate Distance Matrix between the Seqeuences
    #####################################################
    if ($Phylogenetic_Mode or $Phylogenetic_Mode_Sum)
    {
	$MSA_For_Tree="$Target_Seq_And_Templates_Atom_Seq_File.For_Tree.mfa";
	$Tree_File="$Target_Seq_And_Templates_Atom_Seq_File.Semphy_Tree";
	$Tree_Distance_Matrix="$Target_Seq_And_Templates_Atom_Seq_File.Semphy_Tree.Distance_Matrix";
	open (MSA_FOR_TREE,">$MSA_For_Tree") || die "Can't Open MSA For Tree File: '$MSA_For_Tree' $!";
	open (MSA,"$Target_Seq_And_Templates_Atom_Seq_File.mfa") || die "Can't Open MSA File: '$Target_Seq_And_Templates_Atom_Seq_File.mfa' $!";
	my $line=<MSA>;
	if ($line=~/\>(T[0-9]+).*/)
	{
	    print MSA_FOR_TREE ">$1\n";
	    $Reference_Seq_Name=$1;
	}
	elsif ($line=~/\>gi\|([0-9_]+).*/)
	{
	    print MSA_FOR_TREE ">TARGET_$1\n";
	    $Reference_Seq_Name="TARGET_$1";
	}
	elsif ($line=~/\>([A-Z0-9]+_[A-Z0-9]+).*/)
	{
	    print MSA_FOR_TREE ">$1\n";
	    $Reference_Seq_Name=$1;
	}
	while ($line=<MSA>)
	{
	    print MSA_FOR_TREE $line;
	}
	close (MSA_FOR_TREE);
	close (MSA);
	my $SEMPHY_Command="$SEMPHY -s $MSA_For_Tree -T $Tree_File -a 20 --jtt --posteriorDTME -O";
	system ($SEMPHY_Command) if (!-e $Tree_File);
	print "SEMPHY Tree WAS Created At: $Tree_File\n";#<STDIN>;
	WMC::From_Tree_to_Distance_Matrix($Tree_File,$Tree_Distance_Matrix,$Reference_Seq_Name);
    }
    if (!defined $MSA_For_Tree)
    {
	$MSA_For_Tree="$Target_Seq_And_Templates_Atom_Seq_File.mfa";
    }
    ## PREDICT
    ####################
    $Out_File="$Output_Path$Target_Name"."_Templates_Consensus_ContactMap" if (!defined $Out_File);
    if ($Clusters) # The real WMC predictor
    {
	print "WMC::Predict_WMC($Templates_Contact_Maps_List,$MSA_For_Tree,$Out_File,$Tree_Distance_Matrix,$Tree_File,$Power,$Only_Overlap_Mode,$Entropy_Like,$Phylogenetic_Mode,$Phylogenetic_Mode_Sum,0);\n";
	WMC::Predict_WMC($Templates_Contact_Maps_List,$MSA_For_Tree,$Out_File,$Tree_Distance_Matrix,$Tree_File,$Power,$Only_Overlap_Mode,$Entropy_Like,$Phylogenetic_Mode,$Phylogenetic_Mode_Sum,0);
    }
    elsif (!$Clusters) # For All NR types
    {
	WMC::Predict_Consensus($Templates_Contact_Maps_List,$MSA_For_Tree,$Out_File,$Tree_Distance_Matrix,$Power,$Only_Overlap_Mode,$Entropy_Like,$Phylogenetic_Mode,$Phylogenetic_Mode_Sum,0);
    }
    
#    $Predict_Command="$TEMPLATES_CONSENSUS_SCRIPT Contact_Maps_List=$Templates_Contact_Maps_List MSA=$MSA_For_Tree Out=$Out_File" if (!$Clusters);
#    $Predict_Command="$TEMPLATES_CONSENSUS_SCRIPT_WITH_CLUSTERS Contact_Maps_List=$Templates_Contact_Maps_List MSA=$MSA_For_Tree Out=$Out_File Tree=$Tree_File" if ($Clusters);
#    $Predict_Command=$Predict_Command." -Only_Overlap" if ($Only_Overlap_Mode);
#    $Predict_Command=$Predict_Command." Distances= $Tree_Distance_Matrix" if ($Phylogenetic_Mode or $Phylogenetic_Mode_Sum);
#    $Predict_Command=$Predict_Command." -Entropy_Like" if ($Entropy_Like);
#    $Predict_Command=$Predict_Command." -Phylogenetic_Mode" if ($Phylogenetic_Mode);
#    $Predict_Command=$Predict_Command." -Phylogenetic_Sum_Mode" if ($Phylogenetic_Mode_Sum);
#    $Predict_Command=$Predict_Command." Power=$Power" if ($Power>1); # Considering the 1/Distance^Power as weight
#    print $Predict_Command,"\n";
#    system ($Predict_Command);
    
    ## ADD TARGET CONTACT MAP
    ############################
    if (defined $Target_PDB_ID)
    {
	my $Prediction_File_With_CSU=$Out_File."_With_CSU";
	print "WMC::ADD_CSU_CONTACT_MAP_TO_PREDICTION_FILE($Out_File,$Prediction_File_With_CSU,$Output_Path,$Target_File,$Target_PDB_ID);\n";
	WMC::ADD_CSU_CONTACT_MAP_TO_PREDICTION_FILE($Out_File,$Prediction_File_With_CSU,$Output_Path,$Target_File,$Target_PDB_ID);
	#    print "$ADD_CSU_TO_PREDICTION_FILE Prediction= $Out_File Out= $Prediction_File_With_CSU Tmp_Path= $Output_Path Reff_Seq= $Target_File PDB_ID= $Target_PDB_ID\n";
#	system ("$ADD_CSU_TO_PREDICTION_FILE Prediction= $Out_File Out= $Prediction_File_With_CSU Tmp_Path= $Output_Path Reff_Seq= $Target_File PDB_ID= $Target_PDB_ID");
	print "OUTPUT FILE WITH CSU: $Prediction_File_With_CSU\n";
    }
    print "OUTPUT: $Out_File\n"; 
}
else
{
    print "###### SORRY NO TEMPLATES WERE FOUND... NO WMC PREDICTION...\n SEE $Blast_Against_PDB_Out".".Anlyze_Report FOR DETAILES\n";
}
exit (0);

# End of main of "WMC.pl"

####  Functions section  ####################################################

#############################################################################

# End of script "WMC.pl"

#
# $Log$
#
